Index: /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.h	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/telescope_simulator.h	(revision 642)
@@ -15,4 +15,25 @@
 
         bool Parked;
+
+        INumber GuideNSN[2];
+        INumberVectorProperty *GuideNSNP;
+
+
+        INumber GuideWEN[2];
+        INumberVectorProperty *GuideWENP;
+
+        INumber GuideRateN[2];
+        INumberVectorProperty *GuideRateNP;
+
+        INumberVectorProperty *EqPECNV;
+        INumber EqPECN[2];
+
+        ISwitch PECErrNSS[2];
+        ISwitchVectorProperty *PECErrNSSP;
+
+        ISwitch PECErrWES[2];
+        ISwitchVectorProperty *PECErrWESP;
+
+
     public:
         ScopeSim();
@@ -24,4 +45,12 @@
         virtual bool Disconnect();
         virtual bool ReadScopeStatus();
+        virtual bool initProperties();
+        virtual void ISGetProperties (const char *dev);
+        virtual bool updateProperties();
+        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+
+        virtual bool MoveNS(TelescopeMotionNS dir);
+        virtual bool MoveWE(TelescopeMotionWE dir);
 
         bool Goto(double,double);
Index: /BAORadio/libindi/libindi/drivers/telescope/temmadriver.c
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/temmadriver.c	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/telescope/temmadriver.c	(revision 642)
@@ -803,5 +803,5 @@
 
 	if((status=portRead(local_buffer,-1,TEMMA_TIMEOUT)==SUCCESS)){
-		if(strstr(local_buffer, "stn")==local_buffer){
+                if( ( (unsigned char *) strstr(local_buffer, "stn"))==local_buffer){
 			local_buffer[7]=0;
 			if (strstr(local_buffer,"on")){ /* stanby on */
Index: /BAORadio/libindi/libindi/drivers/video/v4ldriver.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/video/v4ldriver.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/drivers/video/v4ldriver.cpp	(revision 642)
@@ -565,6 +565,14 @@
   int status=0; 
 
- fits_update_key(fptr, TLONG, "EXPOSURE", &(V4LFrame->expose), "Total Exposure Time (ms)", &status); 
- fits_update_key(fptr, TSTRING, "INSTRUME", v4l_base->getDeviceName(), "Webcam Name", &status);
+  char keyname[32], comment[64];
+
+ strncpy(keyname, "EXPOSURE", 32);
+ strncpy(comment, "Total Exposure Time (ms)", 64);
+ fits_update_key(fptr, TLONG, keyname , &(V4LFrame->expose), comment, &status);
+
+ strncpy(keyname, "INSTRUME", 32);
+ strncpy(comment, "Webcam Name", 64);
+ fits_update_key(fptr, TSTRING, keyname, v4l_base->getDeviceName(), comment, &status);
+
  fits_write_date(fptr, &status);
 }
Index: /BAORadio/libindi/libindi/eventloop.c
===================================================================
--- /BAORadio/libindi/libindi/eventloop.c	(revision 641)
+++ /BAORadio/libindi/libindi/eventloop.c	(revision 642)
@@ -422,5 +422,5 @@
 	if (ns < 0) {
 	    perror ("select");
-	    exit(1);
+            return;
 	}
 	
@@ -480,5 +480,5 @@
 	if (read (fd, &c, 1) != 1) {
 	    perror ("read");
-	    exit(1);
+            return;
 	}
 
Index: /BAORadio/libindi/libindi/examples/tutorial_dome.c
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_dome.c	(revision 641)
+++ /BAORadio/libindi/libindi/examples/tutorial_dome.c	(revision 642)
@@ -45,4 +45,6 @@
 #define SNOOP_GROUP     "Snooped"
 
+void closeDome();
+
 /* Connect/Disconnect */
 static ISwitch PowerS[]          	= {{"CONNECT" , "Connect" , ISS_OFF, 0, 0},{"DISCONNECT", "Disconnect", ISS_ON, 0, 0}};
Index: /BAORadio/libindi/libindi/examples/tutorial_four.cpp
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_four.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/examples/tutorial_four.cpp	(revision 642)
@@ -199,5 +199,5 @@
 {
 	// Ignore if not ours 
-        if (strcmp (dev, deviceID))
+        if (strcmp (dev, deviceName()))
             return false;
 
@@ -212,5 +212,5 @@
 	
 	// Ignore if not ours
-        if (strcmp (dev, deviceID))
+        if (strcmp (dev, deviceName()))
             return false;
 
@@ -239,5 +239,5 @@
 {
 	// ignore if not ours //
-        if (strcmp (dev, deviceID))
+        if (strcmp (dev, deviceName()))
             return false;
 
@@ -258,4 +258,6 @@
         }*/
 
+    return DefaultDriver::ISNewSwitch(dev, name, states, names, n);
+
 
 }
Index: /BAORadio/libindi/libindi/indiapi.h
===================================================================
--- /BAORadio/libindi/libindi/indiapi.h	(revision 641)
+++ /BAORadio/libindi/libindi/indiapi.h	(revision 642)
@@ -46,8 +46,9 @@
 <ul>
 <li><a href="indidevapi_8h.html">INDI Device API</a></li>
+<li><a href="classINDI_1_1BaseClient.html">INDI Client API</a></li>
+<li><a href="namespaceINDI.html">INDI Base Drivers</a></li>
 <li><a href="indicom_8h.html">INDI Common Routine Library</a></li>
 <li><a href="lilxml_8h.html">INDI LilXML Library</a></li>
 <li><a href="group__configFunctions.html">Configuration</a></li>
-<li><a href="classINDI_1_1BaseClient.html">Client API</a></li>
 </ul>
 
@@ -75,5 +76,5 @@
 
 /* INDI Library version */
-#define INDI_LIBV	0.8
+#define INDI_LIBV	0.9
 
 /*******************************************************************************
Index: /BAORadio/libindi/libindi/indiserver.c
===================================================================
--- /BAORadio/libindi/libindi/indiserver.c	(revision 641)
+++ /BAORadio/libindi/libindi/indiserver.c	(revision 642)
@@ -752,5 +752,6 @@
     while ( fgets (line, MAXRBUF, fifo.fs) != NULL)
     {
-        fprintf(stderr, "FIFO: %s\n", line);
+        if (verbose)
+            fprintf(stderr, "FIFO: %s\n", line);
 
         tDev[0] = '\0', tDriver[0] = '\0', tConfig[0] = '\0', envDev[0] = '\0', envConfig[0] = '\0';
@@ -789,9 +790,9 @@
                 else if (strstr(token, "\"") || strstr(token, "'"))
                 {
-                    strncat(tDev, ++token, MAXRBUF);
+		    strncat(tDev, ++token, sizeof(tDev)-strlen(tDev)-1);
                     while (token = strsep(&cp, delm) )
                    {
                      strcat(tDev, " ");
-                     strncat(tDev, token, MAXRBUF);
+                     strncat(tDev, token, sizeof(tDev)-strlen(tDev)-1);
                      if ( (tp=strchr(tDev, '\"')) || (tp=strchr(tDev, '\'')))
                      {
@@ -816,9 +817,9 @@
                       if (strstr(token, "\"") || strstr(token, "'"))
                       {
-                       strncat(tConfig, ++token, MAXRBUF);
+                       strncat(tConfig, ++token, sizeof(tConfig)-strlen(tDev)-1);
                        while (token = strsep(&cp, delm) )
                        {
                           strcat(tConfig, " ");
-                          strncat(tConfig, token, MAXRBUF);
+                          strncat(tConfig, token, sizeof(tConfig)-strlen(tDev)-1);
 
                           if ( (tp=strchr(tConfig, '\"')) || (tp=strchr(tConfig, '\'')))
@@ -876,5 +877,5 @@
                   for (dp = dvrinfo; dp < &dvrinfo[ndvrinfo]; dp++)
                    {
-                       if (!strcmp(dp->name, tDriver))
+                       if (!strcmp(dp->name, tDriver) && dp->active==1)
                        {
                            /* If device name is given, check against it before shutting down */
Index: /BAORadio/libindi/libindi/libindi.pc.cmake
===================================================================
--- /BAORadio/libindi/libindi/libindi.pc.cmake	(revision 641)
+++ /BAORadio/libindi/libindi/libindi.pc.cmake	(revision 642)
@@ -6,7 +6,7 @@
 Name: libindi
 Description: Instrument Neutral Distributed Interface
-URL=http://www.indilib.org/
+URL: http://www.indilib.org/
 Version: @CMAKE_INDI_VERSION_STRING@
-Libs: -L@LIB_DESTINATION@ -lindi
-Cflags: -I@INCLUDE_INSTALL_DIR@ -@INCLUDE_INSTALL_DIR@/libindi
+Libs: -L${libdir} -lindi
+Cflags: -I${includedir} -I${includedir}/libindi
 
Index: /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/baseclient.cpp	(revision 642)
@@ -1,2 +1,20 @@
+/*******************************************************************************
+  Copyright(c) 2011 Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
+
 #include <stdlib.h>
 #include <string.h>
@@ -159,8 +177,8 @@
 INDI::BaseDriver * INDI::BaseClient::getDriver(const char * deviceName)
 {
-    vector<devicePtr>::const_iterator devi;
+    vector<INDI::BaseDriver *>::const_iterator devi;
     for ( devi = cDevices.begin(); devi != cDevices.end(); devi++)
         if (!strcmp(deviceName, (*devi)->deviceName()))
-            return (*devi).get();
+            return (*devi);
 
     return NULL;
@@ -170,4 +188,5 @@
 {
   (static_cast<INDI::BaseClient *> (context))->listenINDI();
+  return NULL;
 }
 
@@ -291,16 +310,16 @@
 int INDI::BaseClient::removeDevice( const char * devName, char * errmsg )
 {
-    std::vector<devicePtr>::iterator devicei = cDevices.begin();
-
-    while (devicei != cDevices.end())
+    std::vector<INDI::BaseDriver *>::iterator devicei;
+
+    for (devicei =cDevices.begin(); devicei != cDevices.end();)
     {
       if (strcmp(devName, (*devicei)->deviceName()))
       {
-          cDevices.erase(devicei);
-          //delete (*devicei);
+          delete *devicei;
+          devicei = cDevices.erase(devicei);
           return 0;
       }
-
-      devicei++;
+      else
+          ++devicei;
     }
 
@@ -312,10 +331,10 @@
 {
 
-    std::vector<devicePtr>::const_iterator devicei;
+    std::vector<INDI::BaseDriver *>::const_iterator devicei;
 
     for (devicei = cDevices.begin(); devicei != cDevices.end(); devicei++)
     {
         if (!strcmp(devName, (*devicei)->deviceName()))
-         return (*devicei).get();
+         return (*devicei);
 
     }
@@ -328,5 +347,6 @@
 INDI::BaseDriver * INDI::BaseClient::addDevice (XMLEle *dep, char * errmsg)
 {
-    devicePtr dp(new INDI::BaseDriver());
+    //devicePtr dp(new INDI::BaseDriver());
+    INDI::BaseDriver *dp = new INDI::BaseDriver();
     XMLAtt *ap;
     char * device_name;
@@ -350,5 +370,5 @@
 
     /* ok */
-    return dp.get();
+    return dp;
 }
 
Index: /BAORadio/libindi/libindi/libs/indibase/baseclient.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/baseclient.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/baseclient.h	(revision 642)
@@ -1,2 +1,20 @@
+/*******************************************************************************
+  Copyright(c) 2011 Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
+*******************************************************************************/
+
 #ifndef INDIBASECLIENT_H
 #define INDIBASECLIENT_H
@@ -4,5 +22,4 @@
 #include <vector>
 #include <map>
-#include <boost/shared_ptr.hpp>
 #include <string>
 
@@ -26,4 +43,6 @@
    \attention All notifications functions defined in INDI::BaseMediator must be implemented in the client class even if
    they are not used because these are pure virtual functions.
+
+   \see <a href=http://indilib.org/index.php?title=Learn_how_to_write_INDI_clients>INDI Client Tutorial</a> for more details.
    \author Jasem Mutlaq
 
@@ -33,5 +52,5 @@
 public:
     enum { INDI_DEVICE_NOT_FOUND=-1, INDI_PROPERTY_INVALID=-2, INDI_PROPERTY_DUPLICATED = -3, INDI_DISPATCH_ERROR=-4 };
-    typedef boost::shared_ptr<INDI::BaseDriver> devicePtr;
+    //typedef boost::shared_ptr<INDI::BaseDriver> devicePtr;
 
     BaseClient();
@@ -82,5 +101,5 @@
     /** \returns Returns a vector of all devices created in the client.
     */
-    const vector<devicePtr> & getDrivers() const { return cDevices; }
+    const vector<INDI::BaseDriver *> & getDrivers() const { return cDevices; }
 
     /** \brief Set Binary Large Object policy mode
@@ -152,5 +171,5 @@
     pthread_t listen_thread;
 
-    vector<devicePtr> cDevices;
+    vector<INDI::BaseDriver *> cDevices;
     vector<string> cDeviceNames;
 
